<?php

// -------------------------------------------------------------------------- \\
// Configurer addidtional module. Provides some interfaces                    \\
// -------------------------------------------------------------------------- \\

// Simple InUSE Check
if ( !defined('QF_FOX_STARTED') )
        die('Hacking attempt');

if (defined('QF_CONFIGURER_LOADED'))
    die('Scripting error');

define('QF_CONFIGURER_LOADED', true);

// cache prefix
define('QF_CFGSETS_CACHE_PREFIX', 'CFGSETS.');

class QF2_cfgsets
{
    function QF2_cfgsets()
    {

    }

    function Get_List()
    {
        global $QF;

        // loads config sets list
        $cfg_sets = array_unique($QF->DBase->Do_Select_All('config_sets', Array('set_id')));
        sort($cfg_sets);
        return $cfg_sets;
    }

    function Get_ConfSet($cfgset = 'common')
    {
        global $QF;

        $cachename = QF_CFGSETS_CACHE_PREFIX.$QF->LNG->Ask().'.'.$cfgset;
        if ($conf_set = $QF->Cache->Get($cachename))
            return $conf_set;
        elseif ($configs = $QF->DBase->Do_Select_All('config_sets', '*', Array('set_id' => $cfgset, 'sec_set_id' => $cfgset), 'ORDER BY order_id DESC', QF_SQL_WHERE_OR))
        {
            $out_confs = Array();
            $used_modules = Array();
            foreach($configs as $conf)
            {
                if ($module = $conf['package'])
                    if (!in_array($module, $used_modules))
                    {
                        $QF->LNG->Load_Language($module.'_cfgs');
                        $used_modules[] = $module;
                    }

                $cfgname = $conf['capt'];
                if (substr($cfgname, 0, 2) == 'L_')
                    $cfgname = $QF->LNG->Lang(substr($cfgname, 2));

                $o_conf = Array(
                    'cfg_parent' => $conf['cfg_parent'],
                    'cfg_name'   => $conf['cfg_name'],
                    'module'     => $module,
                    'capt'       => $cfgname,
                    );

                $type_sets = explode('|', $conf['cfg_type']);
                $type = strtolower(array_shift($type_sets));
                if ($type == 'str' || $type == 'int' || $type == 'text')
                {
                    $o_conf['type'] = $type;
                    $par1 = array_shift($type_sets);
                    if (!is_numeric($par1))
                    {
                        $o_conf['subtype'] = $par1;
                        $len1 = (int) array_shift($type_sets);
                    }
                    else
                        $len1 = (int) $par1;
                    $len2 = (int) array_shift($type_sets);
                    if ($len2 > $len1)
                    {
                        $o_conf['min'] = $len1;
                        $o_conf['max'] = $len2;
                    }
                    elseif ($len1 > 0)
                    {
                        $o_conf['min'] = 0;
                        $o_conf['max'] = $len1;
                    }

                    $out_confs[] = $o_conf;
                }
                elseif($type == 'bool')
                {
                    $o_conf['type'] = $type;
                    $out_confs[] = $o_conf;
                }
            }

            $QF->Cache->Set($cachename, $out_confs);

            return $out_confs;
        }
        else
            trigger_error('ConfSets: configs set "'.common.'" is empty', E_USER_WARNING );
        return false;
    }
}
?>